---
title: A/B Test
slug: apis/smart-category-merchandising-ab-test
docTags: 
createdAt: 2022-05-02T10:07:40.000Z
---

:::hint{type="info"}
If you haven't gone through the prerequisites and the v2 structure, please have a look at [Overview](docId\:cZeodl0sKcuv-18IPupLr) &#x20;
:::

Klevu can also power your category pages using A/B Testing. This means that for a given Test and Variant combination, the products for a given category are retrieved using the Visual Merchandising rules configured for that A/B Test and Variant.

## Allocating Variants to Store Categories

Klevu allocates for each Category, an A/B Test and a Variant with their IDs. For Category Merchandising, the type will always be “CAT\_NAV”.

Our recommendation is that this request be polled at an interval between 20 minutes and 1 hour, to get either new allocations or skewed allocations of Variants to Categories that were not yet clicked by a shop customer.

As long as an A/B Test ID is received as a Response on this call, said A/B Test is considered Active. Once an ID is no longer received in the Response of this call, it should be removed from the local browser storage.

For each assignment, the distribution of Variants can be different for the same A/B Test ID and Categories. If a Category with an A/B Test Variant ID is selected and viewed by a Shop Customer, that state of having been visited should be recorded, and once another Variant ID is received on the Response for a visited Category, it should be ignored. If a Variant ID is received for a Category that has not yet been visited by a Shop Customer, that Variant ID can be assigned to the Category and it can overwrite any already-existing values in the local browser storage.

:::ApiMethodV2
```json
{
  "tab": "examples",
  "url": "https://api.ksearchnet.com/abtest/public/allocation/klevu-158755634955912036/",
  "name": "Retrieve all possible A/B test allocation variants",
  "method": "POST",
  "request": {
    "pathParameters": [],
    "queryParameters": [],
    "headerParameters": [],
    "bodyDataParameters": [],
    "formDataParameters": []
  },
  "results": {
    "languages": [
      {
        "id": "w1fWy9MoWmWlHQkZ_JsR4",
        "code": "{\n    \"assigned\": [\n        {\n            \"sourceId\": \"womens;jeans\",\n            \"abTestId\": \"101\",\n            \"abTestVariantId\": \"aaa\", \n            \"type\": \"CAT_NAV\"\n        },\n        {\n            \"sourceId\": \"womens;shirts\",\n            \"abTestId\": \"101\",\n            \"abTestVariantId\": \"bbb\", \n            \"type\": \"CAT_NAV\"\n        },\n        {\n            \"sourceId\": \"mens;hoodies\",\n            \"abTestId\": \"101\",\n            \"abTestVariantId\": \"aaa\", \n            \"type\": \"CAT_NAV\"\n        },\n        {\n            \"sourceId\": \"kids;toys\",\n            \"abTestId\": \"202\",\n            \"abTestVariantId\": \"xyz\", \n            \"type\": \"CAT_NAV\"\n        }\n    ]\n}",
        "language": "200",
        "customLabel": ""
      }
    ],
    "selectedLanguageId": "w1fWy9MoWmWlHQkZ_JsR4"
  },
  "examples": {
    "languages": [
      {
        "id": "1KknGPRJw2qWs1a3iujb2",
        "code": "<?php\n\n$curl = curl_init();\n\ncurl_setopt_array($curl, array(\n  CURLOPT_URL => 'https://api.ksearchnet.com/abtest/public/allocation/klevu-158755634955912036/',\n  CURLOPT_RETURNTRANSFER => true,\n  CURLOPT_ENCODING => '',\n  CURLOPT_MAXREDIRS => 10,\n  CURLOPT_TIMEOUT => 0,\n  CURLOPT_FOLLOWLOCATION => true,\n  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,\n  CURLOPT_CUSTOMREQUEST => 'POST',\n));\n\n$response = curl_exec($curl);\n\ncurl_close($curl);\necho $response;\n",
        "language": "php",
        "customLabel": ""
      },
      {
        "id": "zL-4m-0P-ibcbzKAg-Vz6",
        "code": "OkHttpClient client = new OkHttpClient().newBuilder()\n  .build();\nMediaType mediaType = MediaType.parse(\"text/plain\");\nRequestBody body = RequestBody.create(mediaType, \"\");\nRequest request = new Request.Builder()\n  .url(\"https://api.ksearchnet.com/abtest/public/allocation/klevu-158755634955912036/\")\n  .method(\"POST\", body)\n  .build();\nResponse response = client.newCall(request).execute();",
        "language": "java",
        "customLabel": ""
      },
      {
        "id": "oS3wyEpfh_rZVdo7tvJK0",
        "code": "curl --location --request POST 'https://api.ksearchnet.com/abtest/public/allocation/klevu-158755634955912036/' \\\n--header 'Accept: application/json'",
        "language": "curl",
        "customLabel": ""
      },
      {
        "id": "Wdc7hoEkUM1bDpSS0O32Z",
        "code": "var request = require('request');\nvar options = {\n   'method': 'POST',\n   'url': 'https://api.ksearchnet.com/abtest/public/allocation/klevu-158755634955912036/',\n   'headers': {\n      'Accept': 'application/json'\n   }\n};\nrequest(options, function (error, response) {\n   if (error) throw new Error(error);\n   console.log(response.body);\n});\n",
        "language": "nodejs",
        "customLabel": ""
      },
      {
        "id": "9TSGhG6LfgRBWoAIuFA4U",
        "code": "var myHeaders = new Headers();\nmyHeaders.append(\"Accept\", \"application/json\");\n\nvar requestOptions = {\n   method: 'POST',\n   headers: myHeaders,\n   redirect: 'follow'\n};\n\nfetch(\"https://api.ksearchnet.com/abtest/public/allocation/klevu-158755634955912036/\", requestOptions)\n   .then(response => response.text())\n   .then(result => console.log(result))\n   .catch(error => console.log('error', error));",
        "language": "javascript",
        "customLabel": ""
      }
    ],
    "selectedLanguageId": "1KknGPRJw2qWs1a3iujb2"
  },
  "description": "The end-point is used to reteriving available A/B test variants. ",
  "currentNewParameter": {
    "label": "Body Parameter",
    "value": "bodyDataParameters"
  },
  "autoGeneratedAnchorSlug": "retrieve-all-possible-ab-test-allocation-variants",
  "legacyHash": "uVUu-BrVgpWrXLM-ptkFp"
}
```
:::

## Category Product Search with A/B Test

:::ApiMethodV2
```json
{
  "tab": "request",
  "url": "https://{{Your APIv2 URL}}/cs/v2/search",
  "name": "A/B Test using category merchandising",
  "method": "POST",
  "request": {
    "pathParameters": [],
    "queryParameters": [],
    "headerParameters": [],
    "bodyDataParameters": [
      {
        "kind": "required",
        "name": "typeOfRequest",
        "type": "String",
        "description": "This parameter defines the type of request it is, which should be 'CATNAV' for category merchandising queries. There are other values available, detailed elsewhere in the documentation."
      },
      {
        "kind": "required",
        "name": "categoryPath",
        "type": "String",
        "description": "Specify the name of the category to retrieve results from, in the same case and format as it is indexed with Klevu.\n\nFor nested categories, use the ; character to separate the hierarchy. For example, for 'Mens > Shoes > Trainers and Sneakers' you would specify: Mens;Shoes;Trainers and Sneakers."
      },
      {
        "kind": "required",
        "name": "abTestId",
        "type": "string",
        "description": "The unique identifier of the A/B Test."
      },
      {
        "kind": "required",
        "name": "abTestVariantId",
        "type": "string",
        "description": "The unique identifier of the A/B Test Variant."
      }
    ],
    "formDataParameters": []
  },
  "results": {
    "languages": [
      {
        "id": "3XlvmT855lGkJOht0nPXg",
        "code": "{\n    \"meta\": {\n        \"qTime\": 16,\n        \"responseCode\": 200\n    },\n    \"queryResults\": [\n        {\n            \"id\": \"categoryProducts\",\n            \"meta\": {\n                \"qTime\": 12,\n                \"noOfResults\": 12,\n                \"totalResultsFound\": 73,\n                \"typeOfSearch\": \"WILDCARD_AND\",\n                \"offset\": 0,\n                \"debuggingInformation\": {},\n                \"notificationCode\": 1,\n                \"searchedTerm\": \"*\",\n                \"apiKey\": \"klevu-156925593843210765\",\n                \"isPersonalised\": false\n            },\n            \"records\": [\n                {\n                    \"discount\": \"\",\n                    \"hideGroupPrices\": \"\",\n                    \"type\": \"Hoodies & Sweatshirts\",\n                    \"itemGroupId\": \"4384033833022\",\n                    \"freeShipping\": \"\",\n                    \"storeBaseCurrency\": \"GBP\",\n                    \"price\": \"75.00\",\n                    \"toPrice\": \"\",\n                    \"imageUrl\": \"https://cdn.shopify.com/s/files/1/0116/9457/1582/products/wj01-red_main_c9193846-bc80-4537-b810-4f6ad82dd6fe_medium.jpg?v=1575478019\",\n                    \"currency\": \"GBP\",\n                    \"inStock\": \"yes\",\n                    \"id\": \"31366456541246\",\n                    \"imageHover\": \"\",\n                    \"sku\": \"WJ01-S-Red\",\n                    \"brand\": \"KSD\",\n                    \"startPrice\": \"\",\n                    \"image\": \"https://cdn.shopify.com/s/files/1/0116/9457/1582/products/wj01-red_main_c9193846-bc80-4537-b810-4f6ad82dd6fe_medium.jpg?v=1575478019\",\n                    \"deliveryInfo\": \"\",\n                    \"hideAddToCart\": \"\",\n                    \"salePrice\": \"75.0\",\n                    \"swatchesInfo\": \"\",\n                    \"weight\": \"\",\n                    \"klevu_category\": \"KLEVU_PRODUCT;Products;;Jackets;;Hoodies & Sweatshirts  @ku@kuCategory@ku@\",\n                    \"totalVariants\": 0,\n                    \"groupPrices\": \"\",\n                    \"url\": \"https://jsv2-shopify-demo.ksearchmisc.com/products/stellar-solar-jacket-s-red\",\n                    \"tags\": \"Cold-whether, comfortable, crewneck, Grayson, Hoodie, machine, Sweatshirt, winter, Wool\",\n                    \"size\": \"Small\",\n                    \"name\": \"Stellar Solar Jacket\",\n                    \"shortDesc\": \"Beat the heat and protect yourself from sunrays with the Stellar Solar Jacket. It's loaded with all the engineered features you need for an intense, safe outdoor workout: 100% UV protection, a breathable perforated construction, and advanced moist\",\n                    \"category\": \"Jackets;;Hoodies & Sweatshirts\"\n                },\n                {\n                    \"discount\": \"\",\n                    \"hideGroupPrices\": \"\",\n                    \"type\": \"Jackets\",\n                    \"itemGroupId\": \"4384052215870\",\n                    \"freeShipping\": \"\",\n                    \"storeBaseCurrency\": \"GBP\",\n                    \"price\": \"99.00\",\n                    \"toPrice\": \"\",\n                    \"imageUrl\": \"https://cdn.shopify.com/s/files/1/0116/9457/1582/products/mj08-blue_main_bb248254-73cc-4521-8105-fe2277267348_medium.jpg?v=1575478286\",\n                    \"currency\": \"GBP\",\n                    \"inStock\": \"yes\",\n                    \"id\": \"31366487441470\",\n                    \"imageHover\": \"\",\n                    \"sku\": \"MJ08-XS-Blue\",\n                    \"brand\": \"KSD\",\n                    \"startPrice\": \"\",\n                    \"image\": \"https://cdn.shopify.com/s/files/1/0116/9457/1582/products/mj08-blue_main_bb248254-73cc-4521-8105-fe2277267348_medium.jpg?v=1575478286\",\n                    \"deliveryInfo\": \"\",\n                    \"hideAddToCart\": \"\",\n                    \"salePrice\": \"99.0\",\n                    \"swatchesInfo\": \"\",\n                    \"weight\": \"\",\n                    \"klevu_category\": \"KLEVU_PRODUCT;Products;;Jackets  @ku@kuCategory@ku@\",\n                    \"totalVariants\": 0,\n                    \"groupPrices\": \"\",\n                    \"url\": \"https://jsv2-shopify-demo.ksearchmisc.com/products/lando-gym-jacket-blue\",\n                    \"tags\": \"blue, machine, royal, zipped\",\n                    \"size\": \"Small\",\n                    \"name\": \"Lando Gym Jacket\",\n                    \"shortDesc\": \"The Lando Gym Jacket offers strategic ventilation at perspiration-prone areas, while moisture-wicking technology helps you stay dry. Side-seam pockets house your favorite media device, so you're plugged in when working out. • Gray polyester\",\n                    \"category\": \"Jackets\"\n                },\n                {\n                    \"discount\": \"\",\n                    \"hideGroupPrices\": \"\",\n                    \"type\": \"Jackets\",\n                    \"itemGroupId\": \"4384033341502\",\n                    \"freeShipping\": \"\",\n                    \"storeBaseCurrency\": \"GBP\",\n                    \"price\": \"84.00\",\n                    \"toPrice\": \"\",\n                    \"imageUrl\": \"https://cdn.shopify.com/s/files/1/0116/9457/1582/products/wj04-orange_main_098af8fb-1cf2-473f-907a-10922e39beae_medium.jpg?v=1575478007\",\n                    \"currency\": \"GBP\",\n                    \"inStock\": \"yes\",\n                    \"id\": \"31366455590974\",\n                    \"imageHover\": \"\",\n                    \"sku\": \"WJ04-XS-Orange\",\n                    \"brand\": \"MNH\",\n                    \"startPrice\": \"\",\n                    \"image\": \"https://cdn.shopify.com/s/files/1/0116/9457/1582/products/wj04-orange_main_098af8fb-1cf2-473f-907a-10922e39beae_medium.jpg?v=1575478007\",\n                    \"deliveryInfo\": \"\",\n                    \"hideAddToCart\": \"\",\n                    \"salePrice\": \"84.0\",\n                    \"swatchesInfo\": \"\",\n                    \"weight\": \"\",\n                    \"klevu_category\": \"KLEVU_PRODUCT;Products;;Jackets  @ku@kuCategory@ku@\",\n                    \"totalVariants\": 0,\n                    \"groupPrices\": \"\",\n                    \"url\": \"https://jsv2-shopify-demo.ksearchmisc.com/products/ingrid-running-jacket-orange\",\n                    \"tags\": \"comfort, machine, royal, running, zipped\",\n                    \"size\": \"Small\",\n                    \"name\": \"Ingrid Running Jacket\",\n                    \"shortDesc\": \"The Ingrid Running Jacket combines sleek design and high performance with slim, contoured fit and moisture-wicking fabric. It features a full-zip construction and a collared neck to keep the elements out and body heat in. • Slim fit. • Moi\",\n                    \"category\": \"Jackets\"\n                },\n                {\n                    \"discount\": \"\",\n                    \"hideGroupPrices\": \"\",\n                    \"type\": \"Jackets\",\n                    \"itemGroupId\": \"4384031244350\",\n                    \"freeShipping\": \"\",\n                    \"storeBaseCurrency\": \"GBP\",\n                    \"price\": \"77.00\",\n                    \"toPrice\": \"\",\n                    \"imageUrl\": \"https://cdn.shopify.com/s/files/1/0116/9457/1582/products/wj06-green_main_30b7fa7f-a3ce-4513-9307-822bf013a89d_medium.jpg?v=1575477963\",\n                    \"currency\": \"GBP\",\n                    \"inStock\": \"yes\",\n                    \"id\": \"31366453067838\",\n                    \"imageHover\": \"\",\n                    \"sku\": \"WJ06-XS-Green\",\n                    \"brand\": \"KSD\",\n                    \"startPrice\": \"\",\n                    \"image\": \"https://cdn.shopify.com/s/files/1/0116/9457/1582/products/wj06-green_main_30b7fa7f-a3ce-4513-9307-822bf013a89d_medium.jpg?v=1575477963\",\n                    \"deliveryInfo\": \"\",\n                    \"hideAddToCart\": \"\",\n                    \"salePrice\": \"77.0\",\n                    \"swatchesInfo\": \"\",\n                    \"weight\": \"\",\n                    \"klevu_category\": \"KLEVU_PRODUCT;Products;;Jackets  @ku@kuCategory@ku@\",\n                    \"totalVariants\": 0,\n                    \"groupPrices\": \"\",\n                    \"url\": \"https://jsv2-shopify-demo.ksearchmisc.com/products/juno-jacket-green\",\n                    \"tags\": \"adjustable, comfort, machine, royal, running, zipped\",\n                    \"size\": \"Large\",\n                    \"name\": \"Juno Jacket\",\n                    \"shortDesc\": \"On colder-than-comfortable mornings, you'll love warming up in the Juno All-Ways Performanc Jacket, designed to compete with wind and chill. Built-in Cocona® technology aids evaporation, while a special zip placket and stand-up collar keep your ne\",\n                    \"category\": \"Jackets\"\n                },\n                {\n                    \"discount\": \"\",\n                    \"hideGroupPrices\": \"\",\n                    \"type\": \"Jackets\",\n                    \"itemGroupId\": \"4384052084798\",\n                    \"freeShipping\": \"\",\n                    \"storeBaseCurrency\": \"GBP\",\n                    \"price\": \"99.00\",\n                    \"toPrice\": \"\",\n                    \"imageUrl\": \"https://cdn.shopify.com/s/files/1/0116/9457/1582/products/mj08-green_main_7f692ff8-45b0-4d08-8371-a2044df82752_medium.jpg?v=1575478284\",\n                    \"currency\": \"GBP\",\n                    \"inStock\": \"yes\",\n                    \"id\": \"31366487310398\",\n                    \"imageHover\": \"\",\n                    \"sku\": \"MJ08-XS-Green\",\n                    \"brand\": \"MNH\",\n                    \"startPrice\": \"\",\n                    \"image\": \"https://cdn.shopify.com/s/files/1/0116/9457/1582/products/mj08-green_main_7f692ff8-45b0-4d08-8371-a2044df82752_medium.jpg?v=1575478284\",\n                    \"deliveryInfo\": \"\",\n                    \"hideAddToCart\": \"\",\n                    \"salePrice\": \"99.0\",\n                    \"swatchesInfo\": \"\",\n                    \"weight\": \"\",\n                    \"klevu_category\": \"KLEVU_PRODUCT;Products;;Jackets  @ku@kuCategory@ku@\",\n                    \"totalVariants\": 0,\n                    \"groupPrices\": \"\",\n                    \"url\": \"https://jsv2-shopify-demo.ksearchmisc.com/products/lando-gym-jacket-green\",\n                    \"tags\": \"green, machine, royal, zipped\",\n                    \"size\": \"Medium\",\n                    \"name\": \"Lando Gym Jacket\",\n                    \"shortDesc\": \"The Lando Gym Jacket offers strategic ventilation at perspiration-prone areas, while moisture-wicking technology helps you stay dry. Side-seam pockets house your favorite media device, so you're plugged in when working out. • Gray polyester\",\n                    \"category\": \"Jackets\"\n                },\n                {\n                    \"discount\": \"\",\n                    \"hideGroupPrices\": \"\",\n                    \"type\": \"Jackets\",\n                    \"itemGroupId\": \"4384051527742\",\n                    \"freeShipping\": \"\",\n                    \"storeBaseCurrency\": \"GBP\",\n                    \"price\": \"66.00\",\n                    \"toPrice\": \"\",\n                    \"imageUrl\": \"https://cdn.shopify.com/s/files/1/0116/9457/1582/products/mj10-red_main_9e1898b9-9d4a-41df-8dc6-7d31cd23c34e_medium.jpg?v=1575478275\",\n                    \"currency\": \"GBP\",\n                    \"inStock\": \"yes\",\n                    \"id\": \"31366485966910\",\n                    \"imageHover\": \"\",\n                    \"sku\": \"MJ10-XS-Red\",\n                    \"brand\": \"MNH\",\n                    \"startPrice\": \"\",\n                    \"image\": \"https://cdn.shopify.com/s/files/1/0116/9457/1582/products/mj10-red_main_9e1898b9-9d4a-41df-8dc6-7d31cd23c34e_medium.jpg?v=1575478275\",\n                    \"deliveryInfo\": \"\",\n                    \"hideAddToCart\": \"\",\n                    \"salePrice\": \"66.0\",\n                    \"swatchesInfo\": \"\",\n                    \"weight\": \"\",\n                    \"klevu_category\": \"KLEVU_PRODUCT;Products;;Tops;;Jackets  @ku@kuCategory@ku@\",\n                    \"totalVariants\": 0,\n                    \"groupPrices\": \"\",\n                    \"url\": \"https://jsv2-shopify-demo.ksearchmisc.com/products/mars-heattech-trade-pullover-red\",\n                    \"tags\": \"machine, red, royal, zipped\",\n                    \"size\": \"Medium\",\n                    \"name\": \"Mars HeatTech™ Pullover\",\n                    \"shortDesc\": \"The Mars HeatTech™ Jacket defense against winter climes so you can play offense in the park, on the trail or in the deck chair. Great for the ski lodge or stadium, it features a wind- and water-resistant outer shell with a draw-cord hood and deep\",\n                    \"category\": \"Tops;;Jackets\"\n                },\n                {\n                    \"discount\": \"\",\n                    \"hideGroupPrices\": \"\",\n                    \"type\": \"Jackets\",\n                    \"itemGroupId\": \"4384033603646\",\n                    \"freeShipping\": \"\",\n                    \"storeBaseCurrency\": \"GBP\",\n                    \"price\": \"56.25\",\n                    \"toPrice\": \"\",\n                    \"imageUrl\": \"https://cdn.shopify.com/s/files/1/0116/9457/1582/products/wj02-blue_main_8549c057-4567-4b63-ac2e-2068d345ff28_medium.jpg?v=1575478014\",\n                    \"currency\": \"GBP\",\n                    \"inStock\": \"yes\",\n                    \"id\": \"31366456279102\",\n                    \"imageHover\": \"\",\n                    \"sku\": \"WJ02-XS-Blue\",\n                    \"brand\": \"KSD\",\n                    \"startPrice\": \"\",\n                    \"image\": \"https://cdn.shopify.com/s/files/1/0116/9457/1582/products/wj02-blue_main_8549c057-4567-4b63-ac2e-2068d345ff28_medium.jpg?v=1575478014\",\n                    \"deliveryInfo\": \"\",\n                    \"hideAddToCart\": \"\",\n                    \"salePrice\": \"56.25\",\n                    \"swatchesInfo\": \"\",\n                    \"weight\": \"\",\n                    \"klevu_category\": \"KLEVU_PRODUCT;Products;;Jackets  @ku@kuCategory@ku@\",\n                    \"totalVariants\": 0,\n                    \"groupPrices\": \"\",\n                    \"url\": \"https://jsv2-shopify-demo.ksearchmisc.com/products/josie-yoga-jacket-blue\",\n                    \"tags\": \"comfort, machine, royal, running, zipped\",\n                    \"size\": \"Small\",\n                    \"name\": \"Josie Yoga Jacket\",\n                    \"shortDesc\": \"When your near future includes yoga, the cozy comfort of the Josie Yoga Jacket gets your mind and body ready. Stretchy CoolTech™ fabric with zipper pockets makes this jacket the right gear for studio time or teatime after. • Slate rouched n\",\n                    \"category\": \"Jackets\"\n                },\n                {\n                    \"discount\": \"\",\n                    \"hideGroupPrices\": \"\",\n                    \"type\": \"Jackets\",\n                    \"itemGroupId\": \"4384052150334\",\n                    \"freeShipping\": \"\",\n                    \"storeBaseCurrency\": \"GBP\",\n                    \"price\": \"99.00\",\n                    \"toPrice\": \"\",\n                    \"imageUrl\": \"https://cdn.shopify.com/s/files/1/0116/9457/1582/products/mj08-gray_main_3787cf65-8e0a-4540-8f11-6d188980a6eb_medium.jpg?v=1575478285\",\n                    \"currency\": \"GBP\",\n                    \"inStock\": \"yes\",\n                    \"id\": \"31366487375934\",\n                    \"imageHover\": \"\",\n                    \"sku\": \"MJ08-XS-Gray\",\n                    \"brand\": \"KKE\",\n                    \"startPrice\": \"\",\n                    \"image\": \"https://cdn.shopify.com/s/files/1/0116/9457/1582/products/mj08-gray_main_3787cf65-8e0a-4540-8f11-6d188980a6eb_medium.jpg?v=1575478285\",\n                    \"deliveryInfo\": \"\",\n                    \"hideAddToCart\": \"\",\n                    \"salePrice\": \"99.0\",\n                    \"swatchesInfo\": \"\",\n                    \"weight\": \"\",\n                    \"klevu_category\": \"KLEVU_PRODUCT;Products;;Jackets  @ku@kuCategory@ku@\",\n                    \"totalVariants\": 0,\n                    \"groupPrices\": \"\",\n                    \"url\": \"https://jsv2-shopify-demo.ksearchmisc.com/products/lando-gym-jacket-gray\",\n                    \"tags\": \"gray, machine, royal, zipped\",\n                    \"size\": \"Large\",\n                    \"name\": \"Lando Gym Jacket\",\n                    \"shortDesc\": \"The Lando Gym Jacket offers strategic ventilation at perspiration-prone areas, while moisture-wicking technology helps you stay dry. Side-seam pockets house your favorite media device, so you're plugged in when working out. • Gray polyester\",\n                    \"category\": \"Jackets\"\n                },\n                {\n                    \"discount\": \"\",\n                    \"hideGroupPrices\": \"\",\n                    \"type\": \"Jackets\",\n                    \"itemGroupId\": \"4384033243198\",\n                    \"freeShipping\": \"\",\n                    \"storeBaseCurrency\": \"GBP\",\n                    \"price\": \"84.00\",\n                    \"toPrice\": \"\",\n                    \"imageUrl\": \"https://cdn.shopify.com/s/files/1/0116/9457/1582/products/wj04-white_main_d8fa2b03-08ff-485c-afd1-b3761e70e9ce_medium.jpg?v=1575478004\",\n                    \"currency\": \"GBP\",\n                    \"inStock\": \"yes\",\n                    \"id\": \"31366455427134\",\n                    \"imageHover\": \"\",\n                    \"sku\": \"WJ04-XS-White\",\n                    \"brand\": \"KKE\",\n                    \"startPrice\": \"\",\n                    \"image\": \"https://cdn.shopify.com/s/files/1/0116/9457/1582/products/wj04-white_main_d8fa2b03-08ff-485c-afd1-b3761e70e9ce_medium.jpg?v=1575478004\",\n                    \"deliveryInfo\": \"\",\n                    \"hideAddToCart\": \"\",\n                    \"salePrice\": \"84.0\",\n                    \"swatchesInfo\": \"\",\n                    \"weight\": \"\",\n                    \"klevu_category\": \"KLEVU_PRODUCT;Products;;Jackets  @ku@kuCategory@ku@\",\n                    \"totalVariants\": 0,\n                    \"groupPrices\": \"\",\n                    \"url\": \"https://jsv2-shopify-demo.ksearchmisc.com/products/ingrid-running-jacket-white\",\n                    \"tags\": \"comfort, machine, royal, running, zipped\",\n                    \"size\": \"Medium\",\n                    \"name\": \"Ingrid Running Jacket\",\n                    \"shortDesc\": \"The Ingrid Running Jacket combines sleek design and high performance with slim, contoured fit and moisture-wicking fabric. It features a full-zip construction and a collared neck to keep the elements out and body heat in. • Slim fit. • Moi\",\n                    \"category\": \"Jackets\"\n                },\n                {\n                    \"discount\": \"\",\n                    \"hideGroupPrices\": \"\",\n                    \"type\": \"Jackets\",\n                    \"itemGroupId\": \"4384033308734\",\n                    \"freeShipping\": \"\",\n                    \"storeBaseCurrency\": \"GBP\",\n                    \"price\": \"84.00\",\n                    \"toPrice\": \"\",\n                    \"imageUrl\": \"https://cdn.shopify.com/s/files/1/0116/9457/1582/products/wj04-red_main_5c76d8d8-ad1a-414f-b6b7-9edccc50b955_medium.jpg?v=1575478005\",\n                    \"currency\": \"GBP\",\n                    \"inStock\": \"yes\",\n                    \"id\": \"31366455525438\",\n                    \"imageHover\": \"\",\n                    \"sku\": \"WJ04-XS-Red\",\n                    \"brand\": \"KSD\",\n                    \"startPrice\": \"\",\n                    \"image\": \"https://cdn.shopify.com/s/files/1/0116/9457/1582/products/wj04-red_main_5c76d8d8-ad1a-414f-b6b7-9edccc50b955_medium.jpg?v=1575478005\",\n                    \"deliveryInfo\": \"\",\n                    \"hideAddToCart\": \"\",\n                    \"salePrice\": \"84.0\",\n                    \"swatchesInfo\": \"\",\n                    \"weight\": \"\",\n                    \"klevu_category\": \"KLEVU_PRODUCT;Products;;Jackets  @ku@kuCategory@ku@\",\n                    \"totalVariants\": 0,\n                    \"groupPrices\": \"\",\n                    \"url\": \"https://jsv2-shopify-demo.ksearchmisc.com/products/ingrid-running-jacket-red\",\n                    \"tags\": \"comfort, machine, royal, running, zipped\",\n                    \"size\": \"Large\",\n                    \"name\": \"Ingrid Running Jacket\",\n                    \"shortDesc\": \"The Ingrid Running Jacket combines sleek design and high performance with slim, contoured fit and moisture-wicking fabric. It features a full-zip construction and a collared neck to keep the elements out and body heat in. • Slim fit. • Moi\",\n                    \"category\": \"Jackets\"\n                },\n                {\n                    \"discount\": \"\",\n                    \"hideGroupPrices\": \"\",\n                    \"type\": \"Hoodies & Sweatshirts\",\n                    \"itemGroupId\": \"4384033964094\",\n                    \"freeShipping\": \"\",\n                    \"storeBaseCurrency\": \"GBP\",\n                    \"price\": \"75.00\",\n                    \"toPrice\": \"\",\n                    \"imageUrl\": \"https://cdn.shopify.com/s/files/1/0116/9457/1582/products/wj01-blue_main_d6ed0a23-7d18-42d4-921c-5669f65a7580_medium.jpg?v=1575478022\",\n                    \"currency\": \"GBP\",\n                    \"inStock\": \"yes\",\n                    \"id\": \"31366456672318\",\n                    \"imageHover\": \"\",\n                    \"sku\": \"WJ01-S-Blue\",\n                    \"brand\": \"MNH\",\n                    \"startPrice\": \"\",\n                    \"image\": \"https://cdn.shopify.com/s/files/1/0116/9457/1582/products/wj01-blue_main_d6ed0a23-7d18-42d4-921c-5669f65a7580_medium.jpg?v=1575478022\",\n                    \"deliveryInfo\": \"\",\n                    \"hideAddToCart\": \"\",\n                    \"salePrice\": \"75.0\",\n                    \"swatchesInfo\": \"\",\n                    \"weight\": \"\",\n                    \"klevu_category\": \"KLEVU_PRODUCT;Products;;Jackets;;Hoodies & Sweatshirts  @ku@kuCategory@ku@\",\n                    \"totalVariants\": 0,\n                    \"groupPrices\": \"\",\n                    \"url\": \"https://jsv2-shopify-demo.ksearchmisc.com/products/stellar-solar-jacket-s-blue\",\n                    \"tags\": \"Cold-whether, comfortable, crewneck, Grayson, Hoodie, machine, Sweatshirt, winter, Wool\",\n                    \"size\": \"Small\",\n                    \"name\": \"Stellar Solar Jacket\",\n                    \"shortDesc\": \"Beat the heat and protect yourself from sunrays with the Stellar Solar Jacket. It's loaded with all the engineered features you need for an intense, safe outdoor workout: 100% UV protection, a breathable perforated construction, and advanced moist\",\n                    \"category\": \"Jackets;;Hoodies & Sweatshirts\"\n                },\n                {\n                    \"discount\": \"\",\n                    \"hideGroupPrices\": \"\",\n                    \"type\": \"Jackets\",\n                    \"itemGroupId\": \"4384052412478\",\n                    \"freeShipping\": \"\",\n                    \"storeBaseCurrency\": \"GBP\",\n                    \"price\": \"72.00\",\n                    \"toPrice\": \"\",\n                    \"imageUrl\": \"https://cdn.shopify.com/s/files/1/0116/9457/1582/products/mj07-red_main_7fb57683-fddb-44a9-90aa-fc03536bbd90_medium.jpg?v=1575478289\",\n                    \"currency\": \"GBP\",\n                    \"inStock\": \"yes\",\n                    \"id\": \"31366487769150\",\n                    \"imageHover\": \"\",\n                    \"sku\": \"MJ07-XS-Red\",\n                    \"brand\": \"KKE\",\n                    \"startPrice\": \"\",\n                    \"image\": \"https://cdn.shopify.com/s/files/1/0116/9457/1582/products/mj07-red_main_7fb57683-fddb-44a9-90aa-fc03536bbd90_medium.jpg?v=1575478289\",\n                    \"deliveryInfo\": \"\",\n                    \"hideAddToCart\": \"\",\n                    \"salePrice\": \"72.0\",\n                    \"swatchesInfo\": \"\",\n                    \"weight\": \"\",\n                    \"klevu_category\": \"KLEVU_PRODUCT;Products;;Jackets  @ku@kuCategory@ku@\",\n                    \"totalVariants\": 0,\n                    \"groupPrices\": \"\",\n                    \"url\": \"https://jsv2-shopify-demo.ksearchmisc.com/products/orion-two-tone-fitted-jacket-red\",\n                    \"tags\": \"machine, red, royal, zipped\",\n                    \"size\": \"Large\",\n                    \"name\": \"Orion Two-Tone Fitted Jacket\",\n                    \"shortDesc\": \"While you're getting fit, you need a fitted jacket to match. Striking color blocking patterns on hood, shoulders and arms are hallmarks of the Orion Two-Tone Fitted Jacket. They provide eye-catching contrast against the rich, torso tones of this 1\",\n                    \"category\": \"Jackets\"\n                }\n            ],\n            \"filters\": []\n        }\n    ]\n}",
        "language": "200",
        "customLabel": ""
      }
    ],
    "selectedLanguageId": "3XlvmT855lGkJOht0nPXg"
  },
  "examples": {
    "languages": [
      {
        "id": "jSU7DlYyJ_eUh63YSP682",
        "code": "{\n  \"recordQueries\": [\n    {\n      \"id\": \"categoryProducts\",\n      \"typeOfRequest\": \"CATNAV\",\n      \"settings\": {\n         \"query\": {\n           \"categoryPath\": \"Jackets\"\n         },\n         \"abTestId\": \"9c8bm3o1-osjgoqn9-9mbjudid\",\n         \"abTestVariantId\": \"if92kdmc-98ckcj89-98cjcd9d\"\n      }\n    }\n  ],\n  \"context\": {\n    \"apiKeys\": [\n      \"klevu-156925593843210765\"\n    ]\n  }\n}",
        "language": "json",
        "customLabel": "Request Body (JSON)"
      },
      {
        "id": "8Yg33Te4JzfoWp5yEbmJh",
        "code": "<?php\n\n$curl = curl_init();\n\ncurl_setopt_array($curl, array(\n  CURLOPT_URL => 'https://eucs15v2.ksearchnet.com/cs/v2/search',\n  CURLOPT_RETURNTRANSFER => true,\n  CURLOPT_ENCODING => '',\n  CURLOPT_MAXREDIRS => 10,\n  CURLOPT_TIMEOUT => 0,\n  CURLOPT_FOLLOWLOCATION => true,\n  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,\n  CURLOPT_CUSTOMREQUEST => 'POST',\n  CURLOPT_POSTFIELDS =>'{\n  \"recordQueries\": [\n    {\n      \"id\": \"categoryProducts\",\n      \"typeOfRequest\": \"CATNAV\",\n      \"settings\": {\n         \"query\": {\n            \"categoryPath\": \"Jackets\"\n         },\n         \"abTestId\": \"9c8bm3o1-osjgoqn9-9mbjudid\",\n         \"abTestVariantId\": \"if92kdmc-98ckcj89-98cjcd9d\"\n      }\n    }\n  ],\n  \"context\": {\n    \"apiKeys\": [\n      \"klevu-156925593843210765\"\n    ]\n  }\n}',\n  CURLOPT_HTTPHEADER => array(\n    'Content-Type: application/json'\n  ),\n));\n\n$response = curl_exec($curl);\n\ncurl_close($curl);\necho $response;\n",
        "language": "php",
        "customLabel": ""
      },
      {
        "id": "WCDgTsSqAXfiwklk2V174",
        "code": "var data = JSON.stringify({\"recordQueries\":[{\"id\":\"categoryProducts\",\"typeOfRequest\":\"CATNAV\",\"settings\":{\"query\":{\"categoryPath\":\"Jackets\"},\"abTestId\":\"9c8bm3o1-osjgoqn9-9mbjudid\",\"abTestVariantId\":\"if92kdmc-98ckcj89-98cjcd9d\"}}],\"context\":{\"apiKeys\":[\"klevu-156925593843210765\"]}});\n\nvar xhr = new XMLHttpRequest();\nxhr.withCredentials = false;\n\nxhr.addEventListener(\"readystatechange\", function() {\n  if(this.readyState === 4) {\n    console.log(this.responseText);\n  }\n});\n\nxhr.open(\"POST\", \"https://eucs15v2.ksearchnet.com/cs/v2/search\");\nxhr.setRequestHeader(\"Content-Type\", \"application/json\");\n\nxhr.send(data);",
        "language": "javascript",
        "customLabel": ""
      },
      {
        "id": "nPW0NIJe-j5R9I5W4BGN0",
        "code": "OkHttpClient client = new OkHttpClient().newBuilder()\n  .build();\nMediaType mediaType = MediaType.parse(\"application/json\");\nRequestBody body = RequestBody.create(mediaType, \"{\\n  \\\"recordQueries\\\": [\\n    {\\n      \\\"id\\\": \\\"categoryProducts\\\",\\n      \\\"typeOfRequest\\\": \\\"CATNAV\\\",\\n      \\\"settings\\\": {\\n        \\\"query\\\": {\\n          \\\"categoryPath\\\": \\\"Jackets\\\"\\n       },\\n       \\\"abTestId\\\": \\\"9c8bm3o1-osjgoqn9-9mbjudid\\\",\\n       \\\"abTestVariantId\\\": \\\"if92kdmc-98ckcj89-98cjcd9d\\\"\\n      }\\n    }\\n  ],\\n  \\\"context\\\": {\\n    \\\"apiKeys\\\": [\\n      \\\"klevu-156925593843210765\\\"\\n    ]\\n  }\\n}\");\nRequest request = new Request.Builder()\n  .url(\"https://eucs15v2.ksearchnet.com/cs/v2/search\")\n  .method(\"POST\", body)\n  .addHeader(\"Content-Type\", \"application/json\")\n  .build();\nResponse response = client.newCall(request).execute();",
        "language": "java",
        "customLabel": ""
      },
      {
        "id": "0Ih7nieKhHFMl7CRY51j_",
        "code": "var request = require('request');\nvar options = {\n  'method': 'POST',\n  'url': 'https://eucs15v2.ksearchnet.com/cs/v2/search',\n  'headers': {\n    'Content-Type': 'application/json'\n  },\n  body: JSON.stringify({\"recordQueries\":[{\"id\":\"categoryProducts\",\"typeOfRequest\":\"CATNAV\",\"settings\":{\"query\":{\"categoryPath\":\"Jackets\"},\"abTestId\":\"9c8bm3o1-osjgoqn9-9mbjudid\",\"abTestVariantId\":\"if92kdmc-98ckcj89-98cjcd9d\"}}],\"context\":{\"apiKeys\":[\"klevu-156925593843210765\"]}})\n\n};\nrequest(options, function (error, response) {\n  if (error) throw new Error(error);\n  console.log(response.body);\n});\n",
        "language": "nodejs",
        "customLabel": ""
      }
    ],
    "selectedLanguageId": "jSU7DlYyJ_eUh63YSP682"
  },
  "description": "This is an example how to fetch products from specific A/B test variant.\n\nNote: {{Your APIv2 URL}} can be found in your KMC under 'Store Settings'",
  "currentNewParameter": {
    "label": "Body Parameter",
    "value": "bodyDataParameters"
  },
  "autoGeneratedAnchorSlug": "ab-test-using-category-merchandising",
  "legacyHash": "zRSNwflRcZgvZNZp9OE34"
}
```
:::

### Try it here!

:::Iframe{code="<iframe src=&#x22;https://codesandbox.io/embed/klevu-api-sendbox-4ktfrp?fontsize=14&hidenavigation=0&theme=dark&view=preview&initialpath=?payload=AbTest&#x22;&#xA;     style=&#x22;width:100%; height:550px; border:0; border-radius: 4px; overflow:hidden;&#x22;&#xA;     title=&#x22;klevu_api sendbox&#x22;&#xA;     allow=&#x22;accelerometer; ambient-light-sensor; camera; encrypted-media; geolocation; gyroscope; hid; microphone; midi; payment; usb; vr; xr-spatial-tracking&#x22;&#xA;     sandbox=&#x22;allow-forms allow-modals allow-popups allow-presentation allow-same-origin allow-scripts&#x22;&#xA;     &#xA;   ></iframe>" iframeHeight="550"}

:::

